PharData::copy
PharData::decompressFiles
PharData
PHP Manual

# PharData::decompress

Decompresses the entire Phar archive

### Description

object PharData::decompress ([ string `$extension` ] )

For tar-based archives, this method decompresses the entire archive.

For Zip-based archives, this method fails with an exception. The zlib extension must be enabled to decompress an archive compressed with gzip compression, and the bzip2 extension must be enabled in order to decompress an archive compressed with bzip2 compression.

In addition, this method automatically renames the file extension of the archive, .tar by default. Alternatively, a file extension may be specified with the second parameter.

### Parameters

`extension`

  For decompressing, the default file extension is .phar.tar. Use this parameter to specify another file extension. Be aware that no non-executable archives cannot contain .phar in their filename.

### Return Values

A PharData object is returned.

### Errors/Exceptions

Throws BadMethodCallException if the zlib extension is not available, or the bzip2 extension is not enabled.

### Examples

Example #1 A PharData::decompress example

`<?php
$p = new PharData('/path/to/my.tar', 0, 'my.tar.gz');
$p['myfile.txt'] = 'hi';
$p['myfile2.txt'] = 'hi';
$p3 = $p2->decompress(); // creates /path/to/my.tar
?>`

### See Also

- PharFileInfo::getCompressedSize
- PharFileInfo::isCompressed
- PharFileInfo::compress
- PharFileInfo::decompress
- PharData::compress
- Phar::canCompress
- Phar::isCompressed
- PharData::compress
- Phar::getSupportedCompression
- PharData::compressFiles
- PharData::decompressFiles